package
{
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.TimerEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.utils.Timer;
	
	import gs.TweenLite;

	public class SlideEngine extends Sprite
	{
		
		private var _stage:Object;
		private var _images:Array;
		
		private var _container:Sprite;
		
		private var _loader:Loader;
		private var _request:URLRequest;
		
		private var _currentImage:int = 0;
		private var _totalImages:int;
		
		private var _timer:Timer;
		private var _delay:Number;
		private var _tweentime:Number;
		
		public function SlideEngine(container:Object, req:URLRequest, delaytime:Number, tweentime:Number)
		{
			super();
			
			_stage		= container;
			_delay		= delaytime;
			_tweentime	= tweentime;
			
			var ulLoader:URLLoader = new URLLoader();
			ulLoader.load(req);
			ulLoader.addEventListener(Event.COMPLETE, xmlLoaded);
		}
		
		private function xmlLoaded(e:Event):void
		{
			var ldr:URLLoader = e.target as URLLoader;
			ldr.removeEventListener(Event.COMPLETE, xmlLoaded);
			
			var xml:XML = new XML(e.target.data);
			var imageList:XMLList = xml.slide;
			_totalImages = imageList.length();
			
			setupImages(imageList);
		}
		
		private function setupImages(list:XMLList):void
		{
			_images = new Array();
			
			var _item:XML;
			for each(_item in list)
			{
				_images.push(_item.image);
			}
			
			initGraphics();
		}
		
		private function initGraphics():void
		{
			_container = new Sprite();
			_stage.addChild(_container);
			
			_loader	= new Loader();
			_request = new URLRequest(_images[_currentImage]);
			
			_container.addChild(_loader);
			
			startSlideshow();
		}
		
		private function startSlideshow():void
		{
			_loader.load(_request);
			_loader.contentLoaderInfo.addEventListener(Event.COMPLETE, imageLoaded);
			
			_timer = new Timer(_delay);
			_timer.addEventListener(TimerEvent.TIMER, loadNewImage);
			_timer.start();
		}
		
		private function loadNewImage(e:TimerEvent):void
		{
			_request = new URLRequest(_images[_currentImage]);
			_loader.load(_request);
			_timer.stop();
		}
		
		private function imageLoaded(e:Event):void
		{
			_currentImage ++
			
			if(_currentImage == _totalImages)
			{
				_currentImage = 0;
			}
			
			TweenLite.from(_loader, _tweentime, {alpha:0});
			
			_timer.start();
		}
	}
}